package com.googlecode.jpattern.gwt.client.communication;

import com.googlecode.jpattern.gwt.shared.IWebResult;

/**
 * 
 * @author Francesco Cina'
 *
 */
public abstract class AProxy<T extends IWebResult> {

	private final ICallbackAction<T> callbackAction;

	public AProxy(ICallbackAction<T> callbackAction) {
		this.callbackAction = callbackAction;
	}
	
	public void call() throws Exception {
		execute(callbackAction);
	}
	
	protected abstract void execute(ICallbackAction<T> callbackAction) throws Exception;
	
}
